;
; setup.asm - Setup screen
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;**************************************************
;Setup
;
;**************************************************

tmp		= $f7
togg		= $f9

ingetin		= $f142

call_setup	.proc
		sei
		lda #6
		sta msgmode
		bit $d011
		bpl *-3
		bit $d011
		bmi *-3
		sta $d020
		sta $d021
		lda #11
		sta $d011
		lda 650
		sta ism
		lda 648
		sta m648
		lda #4
		sta 648
		jsr LWNO_print_imediate
		.byte 13,5,147,8,14,154	;White, clr, sh+C=, lower, lt.blue

		.text "      "
		.if PC_DUART=1
		.text "  "
		.fi

		.text 128+"I",128+"D",128+"E","64 ",128+"I",128+"D",128+"E",128+"D",128+"O",128+"S"," "
		#version
		.if SUPERCPU=1
		.text 128+"S"
		.fi
		.text " "

		.if PC_DUART=0
		.text 128+"P",128+"A",128+"R",128+"A",128+"L",128+"L",128+"E",128+"L"
		.else
		.text 128+"D",128+"U",128+"A",128+"R",128+"T"
		.fi

		.byte 13
		.text "           "
		.text 128+"C",128+"M",128+"O",128+"S"," "
		.text 128+"S",128+"E",128+"T",128+"U",128+"P"," "
		.text 128+"U",128+"T",128+"I",128+"L",128+"I",128+"T",128+"Y"
		.byte 13
		.text "            "
		.text 128+"T",128+"H",128+"E"," "
		.text 128+"I",128+"D",128+"E","64 "
		.text 128+"P",128+"R",128+"O",128+"J",128+"E",128+"C",128+"T"
		.byte 13
		.byte 5,176,17,157,157,174,221;white, +, down, left, left, |
		.byte 0

		lda #<$4c7
		sta tmp
		lda #>$4c7
		sta tmp+1

		ldy #0
		ldx #17
rc		lda #93
		sta (tmp),y
		iny
		sta (tmp),y

		tya
		clc
		adc #39
		tay
		bcc *+6
		inc tmp+1
		inc togg+1
		dex
		bne rc

		clc
		ldy #0
		ldx #21
		jsr $fff0
		jsr LWNO_print_imediate
		.byte 171,13,157,179,221
		.text 155,128+"R","UN/",128+"S","TOP : ",128+"Q","UIT";gray3
		.text "          ",128+"C",128+"R",128+"S",128+"R"," : ",128+"M","OVE  "
		.byte 5,221,221,155
		.text 128+"C","=       : ",128+"S","AVE"
		.text "          +/-  : ",128+"M","ODIFY"
		.byte 5,221,173,0

		lda #<tt0
		ldy #>tt0
		jsr printpg

		sei
		lda #<irq
		sta $0314
		lda #>irq
		sta $0315
		ldx #37
rt		lda #64
		sta $0479,x
		sta $0749,x
		sta $07c1,x
		dex
		bpl rt
		lda #1
		sta $cc			;cursor off
		lda #125		
		sta $07e7
		lda #3
		sta retry		;ram teszt retry
		sta $dd00
		lda #128
		sta 650			;ismetles
		asl
		ldx #63
rh		sta $033f,x
		dex
		bne rh
		sta hol
		stx $d012
		stx $dc0e
		stx $d01c
		lda #7
		sta $d017
		sta $d01b
		sta $d01d
		sta $d015
		lda #10
		sta $d027
		sta $d028
		sta $d029
		dex
		stx $0340
		stx $0343
		stx $0346
		stx $0349
		lda #13
		sta $07f8
		sta $07f9
		sta $07fa
		stx showclock
		bit $dc0d

nf		#sta_cfg_open
		jsr LWOP_get_cmos_setup
		bcs joez

		jsr write_ram_burst

		dec retry
		bne nf
		geq k5			

joez		lda #%10010001
                jsr cmos_start
                jsr cmos_read_byte
                sta setup_accu_old
                ldx #6
ore             cmp accuconst,x
                beq lv
                dex
                bne ore
lv              stx setup_accu
		jsr cmos_end
                
                lda #%10000001
                jsr cmos_start
                jsr cmos_read_byte
                jsr cmos_end
                tax
                bpl nstopped
                and #$7f		;start the clock if stopped
                tax
                lda #%10000000
                jsr updatec2
nstopped
		lda setup_accu_old
                and #$f0
                cmp #$a0
                beq kfd
                ldx #31
vd              lda battlow,x
                sta $4cc,x
                lda #3
                sta $d8cc,x
                dex
                bpl vd

kfd		jsr highlight

		lda #27
		sta $d011

kl2re		cli

kl		jsr check_move
		cmp #13			;return
		bne k3
		tay
		ldx hol
		lda #>kl2re
		pha
		lda #<kl2re
execmpont	pha
		lda mpont+4,x
		pha
		lda mpont+3,x
		pha
		lda setup_atribut_exp
		rts
k3
		ldx 654			;C=
		cpx #2
		beq saveandexit2

		cmp #3
		beq k5
		gne kl

saveandexit
		pla
		pla
saveandexit2
		sei
		lda $d011
		bpl *-3
		jsr write_ram_burst
                ldy setup_accu
                ldx accuconst,y
                cpx setup_accu_old
                beq nset
                lda #%10010000
                jsr updatec2
nset		jsr OP_hdinit_drivenumbers
		lda drive_type_exp	;%%% nobug %%%
		beq a1
		#lda0
		sta current_drive_exp
		jsr set_power_management_and_features
a1		lda drive_type_exp+1	;%%% nobug %%%
		beq a2
		lda #1
		sta current_drive_exp
		jsr set_power_management_and_features
a2
k5		#stz_a $d01a
		#stz_aa $d015
		#stz_aa $cf			;hide cursor
		jsr LWOP_get_cmos_setup
		#sta_cfg_16
		bcc iujq
		lda retry
		bne rvg
iujq		jsr LWNO_print_imediate
		.byte 147,17,17,17,17,17,17,17,17,17,17,17,17
		.text "     ",128+"C",128+"M",128+"O",128+"S"," ",128+"R",128+"A",128+"M"
		.text " ERROR, PRESS ANY KEY."
		.byte 0

		lda $d011
		bpl *-3
		lda $d011
		bmi *-3
		ldx #2
		stx $d020
		stx $d021
		lda #27
		sta $d011
		dex
		stx $d01a
		jsr ingetin
		beq *-3
		#stz_a $d01a
rvg		lda ism
		sta 650
		lda m648
		sta 648
		jmp $e544

discardexit
		pla
		pla
		#jmps k5

;---------------------------------------
;---------------------------------------
standardstart
		jsr backlight
		#stz_a $d015
		lda #<tt1
		ldy #>tt1
		jsr printpg
		lda #mpont1-mpont
                jsr highlight2
		#stz_a showclock
		#sta_cfg_open

standardloop
		#ldy_l_a setup_paper_exp
		#lda0
		jsr printcol
		#ldy_l_a setup_border_exp
		lda #40
		jsr printcol
		#ldy_l_a setup_chars_exp
		lda #80
		jsr printcol

		lda #<$5cb
		sta togg
		lda #>$5cb
		sta togg+1
		ldy #0
		lda #%11000000
		and setup_atribut_exp
		cmp #%01000000
		bne *+4
		lda #%00000000
		lsr a
		lsr a
		lsr a
		ldy #0
		jsr toggle2
		lda setup_boot_drive_exp
		jsr printnumdev

		lda #<$61b
		sta togg
		lda #>$61b
		sta togg+1
		ldy #0
		lda #%00100000
		jsr toggle
		lda #%00010000
		jsr toggle
		lda #%00001000
		jsr toggle
		lda #%00000100
		jsr toggle
		lda #%00000010
		jsr toggle
                .if DE32_EXISTS=1
		lda #%00000001
                .else
                lda #%00000000
                .fi
		jsr toggle
		lda direct_write_exp
		and #1
		jsr toggle4
                inc togg+1
                lda setup_accu
                asl
                asl
                asl
                adc #152
                jsr toggle2

stdx		jsr check_move
		bne sk3
		tay
		ldx hol
		lda #>(standardloop-1)
		pha
		lda #<(standardloop-1)
		#jmps execmpont
sk3
		ldx 654			;C=
		cpx #2
		beq *+6
		cmp #3
		bne stdx

		#lda0

returnmain
		pha
		jsr backlight
		#stz_a $d015
		lda #<tt0
		ldy #>tt0
		sty showclock
		jsr printpg
		pla
highlight2    	sta hol
		jsr highlight
		lda #7
		sta $d015
		rts

check_move
		#sta_cfg_16
		ldx #1
		stx $d01a
		jsr ingetin
		ldx #0
		stx $d01a
		#sta_cfg_open
		cmp #29			;right
		beq *+6
		cmp #17			;down
		bne sk1
		jsr backlight
		lda hol
		cmp #mpont1-mpont-5
		beq sk1k
		cmp #mpont3-mpont-5
		beq sk1k
		cmp #mpont2-mpont-5
		beq sk1k
		cmp #mponte-mpont-5
		beq sk1k
		clc
		adc #5
sk1k		sta hol
		jsr highlight
		#jmps check_move
sk1
		cmp #157		;left
		beq *+6
		cmp #145		;up
		bne sk2
		jsr backlight
		lda hol
		beq sk2k
		cmp #mpont1-mpont
		beq sk2k
		cmp #mpont3-mpont
		beq sk2k
		cmp #mpont2-mpont
		beq sk2k
		sec
		sbc #5
sk2k		sta hol
		jsr highlight
		#jmps check_move
sk2
		cmp #"-"
		beq *+8
		cmp #"+"
		beq *+4
		cmp #13
		rts
;---------------------------------------
;---------------------------------------
advancedstart
		jsr backlight
		#stz_a $d015
		lda #<tt2
		ldy #>tt2
		jsr printpg
		jsr LWNO_print_imediate
		.text 13,13,29,128+"S","LAVE ",0

		lda #<tt2i
		ldy #>tt2i
                sta tmp
                sty tmp+1
		jsr printpgin;O_print_ay
		lda #mpont2-mpont
		jsr highlight2
		#sta_cfg_open

advancedloop

		lda #<$503
		sta togg
		lda #>$503
		sta togg+1
		ldy #0
		lda #%00001111
		and setup_powerman_exp
		beq chk
		asl a
		asl a
		asl a
		adc #24
chk		jsr toggle2
		lda #%00001000
		jsr toggle3
		lda #%00000100
		jsr toggle3
		lda #%00000010
		jsr toggle3
		lda #%00000001
		jsr toggle3
		lda setup_linear_hdd0_exp
		jsr printnum2

		lda #$6b
		sta togg
		lda #$06
		sta togg+1
		ldy #0
		lda setup_powerman_exp
		and #%11110000
		lsr a
		beq ch2
		adc #24
ch2		jsr toggle2
		lda #%10000000
		jsr toggle3
		lda #%01000000
		jsr toggle3
		lda #%00100000
		jsr toggle3
		lda #%00010000
		jsr toggle3
		lda setup_linear_hdd1_exp
		jsr printnum2

advx		jsr check_move
		bne ak3
		tay
		ldx hol
		#psr advancedloop
		lda mpont+4,x
		pha
		lda mpont+3,x
		pha
		lda setup_features_exp
		rts

ak3
		ldx 654			;C=
		cpx #2
		beq *+6
		cmp #3
		bne advx
		lda #10
		gne returnmain

;---------------------------------------
;---------------------------------------
devicestart
		jsr backlight
		#stz_a $d015
		lda #<tt3
		ldy #>tt3
		jsr printpg

		lda #mpont3-mpont
		jsr highlight2
		#sta_cfg_open

deviceloop
		lda #<$4b3
		sta togg
		lda #>$4b3
		sta togg+1

		lda setup_lcd_exp
		ldy #0
		jsr printnumdev
		lda setup_floppy8_exp
		ldy #80
		jsr printnumdev
		lda setup_floppy9_exp
		ldy #120
		jsr printnumdev
		lda setup_floppy10_exp
		ldy #160
		jsr printnumdev
		lda setup_floppy11_exp
		ldy #200
		jsr printnumdev

		lda #<($4b3+280)
		sta togg
		lda #>($4b3+280)
		sta togg+1
		lda setup_hdd0_exp
		ldy #0
		jsr printnumdev
		lda setup_hdd1_exp
		ldy #40
		jsr printnumdev
		lda setup_pc_exp
		ldy #120
		jsr printnumdev


devx		jsr check_move
		bne ak4
		tay
		ldx hol
		#psr deviceloop
		lda mpont+4,x
		pha
		lda mpont+3,x
		pha
		lda setup_features_exp
		rts

ak4
		ldx 654			;C=
		cpx #2
		beq *+6
		cmp #3
		bne devx
		lda #5
		gne returnmain

;---------------------------------------
;---------------------------------------

irq		ldx showclock
		bmi noclock
		bne noclock2
		#sta_cfg_open
		jsr LWOP_read_clock
		jsr showtime
		#sta_cfg_16
                ldx #5
noclock2	dex
		stx showclock
noclock		jsr $ea87
		lda 651
		cmp #3
		lda #3
                sta $d019
		bcc mdf
		sta 651
mdf		jmp $ea81
;---------------------------------------
printnumdev	clc
		tax
		bne pn
                ldx #"-"
                jsr p
                gne p

printnum2	sec
pn		sty tmp
		sbc #99
		bcc qk
		ldx #49
		sbc #100
		bcc *+5
		inx
		sbc #100
		jsr p

qk		ldx #58
		dex
		adc #10
		bcc *-3
		cpx #49
		bcs qk3
		cpy tmp
		beq qk2
qk3		jsr p

qk2		adc #47
		tax
		jsr p
		ldx #32
		jsr p
p		pha
		txa
		sta (togg),y
		pla
		iny
		rts
;---------------------------------------
printcol	pha
		ldx #255
rte		inx
		lda colors,x
		asl
		bpl rte
		dey
		bpl rte

		#ply_a
		lda colors,x
df		sta $05f3-200,y
		iny
		inx
		lda colors,x
		cmp #64
		bcc df

		lda #32
		ldx #5
bld		sta $05f3-200,y
                iny
                dex
                bne bld
		rts
;---------------------------------------
toggle3		and setup_features_exp
		#jmps toggle4
toggle		and setup_atribut_exp
toggle4		beq toggle2
		lda #8
toggle2		tax
		lda di,x
		sta (togg),y
		inx
		iny
		txa
		and #7
		bne toggle2+1
		tya
		clc
		adc #32
		tay
		rts
;```````````````````````````````````````
;enable/disable
di		.byte "D",$09,$13,$01
		.byte $02,$0c,$05,$04
		.byte "E",$0e,$01,$02
		.byte $0c,$05,$04,$20
powerup		.byte "P",$0f,$17,$05
		.byte $12,$20,$15,$10
always		.byte "A",$0c,$17,$01
		.byte $19,$13,$20,$20
		.text "1 M"
		.byte $09,$0e,$20,$20,$20
		.text "2 M"
		.byte $09,$0e,$20,$20,$20
		.text "3 M"
		.byte $09,$0e,$20,$20,$20
		.text "4 M"
		.byte $09,$0e,$20,$20,$20
		.text "5 M"
		.byte $09,$0e,$20,$20,$20
		.text "6 M"
		.byte $09,$0e,$20,$20,$20
		.text "7 M"
		.byte $09,$0e,$20,$20,$20
		.text "8 M"
		.byte $09,$0e,$20,$20,$20
		.text "9 M"
		.byte $09,$0e,$20,$20,$20
		.text "10 M"
		.byte $09,$0e,$20,$20
		.text "15 M"
		.byte $09,$0e,$20,$20
		.text "20 M"
		.byte $09,$0e,$20,$20
		.text "30 M"
		.byte $09,$0e,$20,$20
		.text "1 H"
		.byte $0f,$15,$12,$20,$20
		.text "2 H"
		.byte $0f,$15,$12,$20,$20
                .text "B",$01,$14,$14,$05,$12,$19,$20
                .byte "243 ",$15,"A  "
                .byte "291 ",$15,"A  "
                .byte "333 ",$15,"A  "
                .byte "398 ",$15,"A  "
                .byte "409 ",$15,"A  "
                .byte "488 ",$15,"A  "
;--------------------------------------
tt0		.byte 17,17,17,158,12
		.text 128+"S",128+"T",128+"A",128+"N",128+"D",128+"A",128+"R",128+"D"," "
		.text 128+"S",128+"E",128+"T",128+"U",128+"P",13,13
		.byte 12
		.text 128+"D",128+"E",128+"V",128+"I",128+"C",128+"E"," "
		.text 128+"N",128+"U",128+"M",128+"B",128+"E",128+"R",128+"S",13,13
		.byte 12
		.text 128+"A",128+"D",128+"V",128+"A",128+"N",128+"C",128+"E",128+"D"," "
		.text 128+"S",128+"E",128+"T",128+"U",128+"P",13,13
		.byte 12
		.text 128+"R",128+"E",128+"S",128+"T",128+"O",128+"R",128+"E"," "
		.text 128+"D",128+"E",128+"F",128+"A",128+"U",128+"L",128+"T",128+"S",13,13
		.byte 12
		.text 128+"S",128+"A",128+"V",128+"E"," & "
		.text 128+"E",128+"X",128+"I",128+"T",13,13
		.byte 12
		.text 128+"D",128+"I",128+"S",128+"C",128+"A",128+"R",128+"D"," & "
		.text 128+"E",128+"X",128+"I",128+"T",5
		.byte 0
tt1		.text 128+"D","ATE (MM:DD:YY) :"
		.text "    ,"
		.byte 13
		.text 128+"T","IME (HH:MM:SS) :"
		.text " ",29,29," : ",29,29," :"
		.byte 13,13
		.text 128+"P","APER COLOR     :"
		.byte 13
		.text 128+"B","ORDER COLOR    :"
		.byte 13
		.text 128+"C","HAR COLOR      :"
		.byte 13,13
		.text 128+"S","TART BOOT FILE :"
		.byte 13
		.text 128+"B","OOT DEVICE     :"
		.byte 13
		.text "1541 FASTLOADER :"
		.byte 13
		.text 128+"S","ET BASIC CLOCK :"
		.byte 13
		.text 128+"K","EYBOARD REPEAT :"
		.byte 13
		.text 128+"L","OWERCASE CHARS :"
		.byte 13
		.text 128+"U","SE DOS WEDGE   :"
		.byte 13
		.text 128+"C","128 KEYBOARD   :"
		.byte 13
		.text 128+"D","IRECT WRITE    :"
		.byte 13
		.text 128+"A","CCU CHARGING   :"
		.byte 0
;---------------------------------------
tt3		.text 128+"L",128+"C",128+"D"," DISPLAY     :"
		.byte 13,13
		.text 128+"S","ERIAL DEVICE 8 :"
		.byte 13
		.text 128+"S","ERIAL DEVICE 9 :"
		.byte 13
		.text 128+"S","ERIAL DEVICE 10:"
		.byte 13
		.text 128+"S","ERIAL DEVICE 11:"
		.byte 13,13
		.text 128+"H",128+"D",128+"D"," 0 (MASTER)  :"
		.byte 13
		.text 128+"H",128+"D",128+"D"," 1 (SLAVE)   :"
		.byte 13,13
		.text 128+"P",128+"C","-",128+"L",128+"I",128+"N",128+"K","         :"
		.byte 0
;---------------------------------------
;Name of colors
colors		.byte "B",$0c,$01,$03,$0b
		.byte "W",$08,$09,$14,$05
		.byte "R",$05,$04
		.byte "C",$19,$01,$0e
		.byte "P",$15,$12,$10,$0c,$05
		.byte "G",$12,$05,$05,$0e
		.byte "B",$0c,$15,$05
		.byte "Y",$05,$0c,$0c,$0f,$17
		.byte "O",$12,$01,$0e,$07,$05
		.byte "B",$12,$0f,$17,$0e
		.byte "L",$09,$07,$08,$14,$20
		.byte $12,$05,$04
		.byte "D",$01,$12,$0b
		.byte $20,$07,$12,$01,$19
		.byte "M",$05,$04,$09,$15,$0d
		.byte $20,$07,$12,$01,$19
		.byte "L",$09,$07,$08,$14,$20
		.byte $07,$12,$05,$05,$0e
		.byte "L",$09,$07,$08,$14,$20
		.byte $02,$0c,$15,$05
		.byte "L",$09,$07,$08,$14
		.byte $20,$07,$12,$01,$19;Following byte must be >63! (128)
;---------------------------------------
tt2		.text 128+"M","ASTER"
tt2i		.text " DRIVE SETTINGS"
		.byte 13
		.byte 163,163,163,163,163,163,163,163,163,163,163,163,163,163,163,163,163,163,163,163,163
		.byte 13
		.text 128+"P","OWER MANAGEMENT:"
		.byte 13
		.text 128+"R","ETRY ON ERROR  :"
		.byte 13
		.text 128+"W","RITE CACHE     :"
		.byte 13
		.text 128+"R","EAD LOOK-AHEAD :"
		.byte 13
		.text 128+"S","LOW DOWN ",128+"C",128+"D",128+"R",128+"O",128+"M"," :"
		.byte 13
		.text 128+"L","INEAR READ MAX :"
                .byte 0
;---------------------------------------
prthx
		and #15
		ora #48
		sta $04bd,y
		txa
		lsr a
		lsr a
		lsr a
		lsr a
		rts
prthx3		jsr prthx
prthx2		eor #48
		sta $04bc,y
		rts

showtime
		ldy #41
		#ldatax sec_exp		;sec
		jsr prthx3

		ldy #36
		#ldatax min_exp		;min
		jsr prthx3

		ldy #31
		#ldatax hour_exp	;hour
		jsr prthx
		and #3
		bne *+4
		lda #16
		jsr prthx2

		lda month_exp		;month
		and #%00011111
		cmp #16
		bcc *+4
		sbc #6
		tax
		lda dayc1+6,x
		sta $04b8
		lda dayc2+6,x
		sta $04b9
		lda dayc3+6,x
		sta $04ba

		ldy #0
		#ldatax date_exp	;date
		jsr prthx
		and #3
		bne *+4
		lda #16
		jsr prthx2

		ldy #5
		#ldatax year_exp	;year
		jsr prthx3
		cmp #56			;19xx?

		ldx #49
		lda #57
		bcs *+5
		inx
		lda #48			;20xx
		sta $04c0
		stx $04bf

					;calculate day of week
		lda day_exp
                sta oldday
		lda year_exp		;year
		and #240
		lsr a
		sta day_exp
		lsr a
		lsr a
		adc day_exp
		sta day_exp

		#ldatax date_exp       	;date
		and #240
		lsr a
		sta datepuff
		lsr a
		lsr a
		adc datepuff
		sta datepuff
		txa
		and #15
		adc datepuff
		sta datepuff

		lda month_exp		;month
		and #%00011111
		cmp #16
		bcc *+5
		sbc #6
		clc
		tax

		lda year_exp		;year
		and #15
		adc day_exp
		sta day_exp
		lsr a
		bcs bw
		lsr a
		bcs bw2
		cpx #3

		.byte SKIP2
bw		lsr a
		sec
bw2		adc day_exp
		adc datepuff
		adc const1-1,x
		.if SUPERCPU=1
		xba
		lda year_exp
		asl
		xba
		.else
		ldx year_exp
		cpx #$80
		.fi
		sbc #7
		bcs *-2
		tax
		adc #8
		pha
		lda dayc1-249,x
		sta $04b3
		lda dayc2-249,x
		sta $04b4
		lda dayc3-249,x
		sta $04b5
                pla
                cmp oldday
                sta day_exp
                beq bx
		tax
		lda #$8a		;write day of week
                gne updatec2
bx              rts

const1		.byte 6,2,2,5,0,3,5,1,4,6,2,4
monl		.byte $31,$28,$31,$30,$31,$30,$31,$31,$30,$29,0,0,0,0,0,$31,$30,$31
;---------------------------------------
;Menu: x,y,length,routine
;---------------------------------------
mpont		.byte 13,7
		.byte 14
		.word standardstart-1
		.byte 13,9
		.byte 14
		.word devicestart-1
		.byte 13,11
		.byte 14
		.word advancedstart-1
		.byte 13,13
		.byte 16
		.word cmos_default-1
		.byte 13,15
		.byte 11
		.word saveandexit-1
		.byte 13,17
		.byte 14
		.word discardexit-1

mpont1		.byte 24,4		;month
		.byte 3
		.word tmh-1
		.byte 28,4		;day
		.byte 2
		.word tdt-1
		.byte 31,4		;year
		.byte 4
		.word tyr-1
		.byte 19,5		;hour
		.byte 2
		.word thr-1
		.byte 24,5		;min
		.byte 2
		.word tmn-1
		.byte 29,5		;sec
		.byte 2
		.word tsec1-1
		.byte 19,7
		.byte 11
		.word tbg-1
		.byte 19,8
		.byte 11
		.word tbr-1
		.byte 19,9
		.byte 11
		.word tfg-1
		.byte 19,11
		.byte 8
		.word tboot-1
		.byte 19,12
		.byte 2
		.word tbootd-1
		.byte 19,13
		.byte 8
		.word tspeed-1
		.byte 19,14
		.byte 8
		.word tbclk-1
		.byte 19,15
		.byte 8
		.word trep-1
		.byte 19,16
		.byte 8
		.word tlower-1
		.byte 19,17
		.byte 8
		.word twedge-1
		.byte 19,18
		.byte 8
		.word tc128key-1
		.byte 19,19
		.byte 8
		.word tdirect-1
		.byte 19,20
		.byte 7
		.word taccu-1

mpont3
		.byte 19,4
		.byte 2
		.word tlcd-1
		.byte 19,6
		.byte 2
		.word tdr8-1
		.byte 19,7
		.byte 2
		.word tdr9-1
		.byte 19,8
		.byte 2
		.word tdr10-1
		.byte 19,9
		.byte 2
		.word tdr11-1
		.byte 19,11
		.byte 2
		.word thd0-1
		.byte 19,12
		.byte 2
		.word thd1-1
		.byte 19,14
		.byte 2
		.word tpcl-1

mpont2		.byte 19,6		;powerm1
		.byte 8
		.word tpm1-1
		.byte 19,7		;retry1
		.byte 8
		.word tretr1-1
		.byte 19,8		;writecache1
		.byte 8
		.word twch1-1
		.byte 19,9		;lookahead1
		.byte 8
		.word tahed1-1
		.byte 19,10		;slowcd1
		.byte 8
		.word tscd1-1
		.byte 19,11		;Linear
		.byte 3
		.word tlin0-1
		.byte 19,15		;powerm2
		.byte 8
		.word tpm2-1
		.byte 19,16		;retry2
		.byte 8
		.word tretr2-1
		.byte 19,17		;writecache2
		.byte 8
		.word twch2-1
		.byte 19,18		;lookahead2
		.byte 8
		.word tahed2-1
		.byte 19,19		;slowcd2
		.byte 8
		.word tscd2-1
		.byte 19,20		;Linear
		.byte 3
		.word tlin1-1
mponte

;```````````````````````````````````````
tspeed		eor #%00110000
tbclk		eor #%00011000
trep		eor #%00001100
tlower		eor #%00000110
		.if DE32_EXISTS=1
twedge		eor #%00000011
tc128key	eor #%00000001
		.else
twedge		eor #%00000010
tc128key	and #%11111110
		.fi
		sta setup_atribut_exp
		rts
tretr2		eor #%11000000
twch2		eor #%01100000
tahed2		eor #%00110000
tscd2		eor #%00011000
tretr1		eor #%00001100
twch1		eor #%00000110
tahed1		eor #%00000011
tscd1		eor #%00000001
		sta setup_features_exp
		rts
tdirect		lda direct_write_exp
		eor #1
		sta direct_write_exp
		rts
;```````````````````````````````````````
tboot		pha
		and #%11000000
		asl a
		rol a
		rol a
		tax
		pla
		and #%00111111
		ora pluss,x
		cpy #"-"
		bne ggdd
		and #%00111111
		ora minu,x
ggdd		sta setup_atribut_exp
		rts
;```````````````````````````````````````
pluss		.byte %10000000
		.byte %10000000
minu		.byte %11000000
		.byte %00000000
		.byte %00000000
		.byte %10000000
;```````````````````````````````````````
taccu		lda setup_accu
		jsr plusminus
                cmp #255
                bne *+4
                lda #6
                cmp #7
                bcc *+4
                lda #0
		sta setup_accu
		rts
;```````````````````````````````````````
tpm1		lda setup_powerman_exp
		pha
		and #%11110000
		sta setup_powerman_exp
		pla
		jsr col
bbb		ora setup_powerman_exp
		sta setup_powerman_exp
		rts

tpm2		lda setup_powerman_exp
		pha
		and #%00001111
		sta setup_powerman_exp
		pla
		lsr a
		lsr a
		lsr a
		lsr a
		jsr col
		asl a
		asl a
		asl a
		asl a
		#jmps bbb
;```````````````````````````````````````
plusminus	#adc1c			;0-15 +/- (color,etc.)
		cpy #"-"
		bne *+4
		sbc #2
		rts
;```````````````````````````````````````
col		jsr plusminus
		and #15
		rts
;```````````````````````````````````````
drv		jsr plusminus
		cmp #255
                bne *+4
                lda #30
                cmp #1
                bne *+4
                lda #8
		cmp #8
		bcc *+6
		cmp #31
		bcc kfv
		#lda0
kfv		rts
;```````````````````````````````````````
tbg		lda setup_paper_exp
tbgx		jsr col
		cmp setup_chars_exp
		beq tbgx
		sta setup_paper_exp
		rts
;```````````````````````````````````````
tbr		lda setup_border_exp
		jsr col
		sta setup_border_exp
		rts
;```````````````````````````````````````
tfg		lda setup_chars_exp
tfgx		jsr col
		cmp setup_paper_exp
		beq tfgx
		sta setup_chars_exp
		rts
;```````````````````````````````````````
tlcd		lda setup_lcd_exp
		jsr plusminus
		cmp #255
                bne *+4
                lda #7
                cmp #1
                bne *+4
                lda #4
		cmp #4
		bcc *+6
		cmp #8
		bcc kfv2
		#lda0
kfv2		sta setup_lcd_exp
		rts
;```````````````````````````````````````
tbootd		lda setup_boot_drive_exp
		jsr drv
		sta setup_boot_drive_exp
		rts
;```````````````````````````````````````
tlin1		ldx #setup_linear_hdd1_exp-setup_linear_hdd0_exp
		.byte SKIP2
tlin0		ldx #setup_linear_hdd0_exp-setup_linear_hdd0_exp
		lda setup_linear_hdd0_exp,x
		jsr plusminus
		and #127
		sta setup_linear_hdd0_exp,x
		rts
;```````````````````````````````````````
tdr8		ldx #setup_floppy8_exp-setup_drivenumbers_exp
		.byte SKIP2
tdr9		ldx #setup_floppy9_exp-setup_drivenumbers_exp
		.byte SKIP2
tdr10		ldx #setup_floppy10_exp-setup_drivenumbers_exp
		.byte SKIP2
tdr11		ldx #setup_floppy11_exp-setup_drivenumbers_exp
		.byte SKIP2
thd0		ldx #setup_hdd0_exp-setup_drivenumbers_exp
		.byte SKIP2
thd1		ldx #setup_hdd1_exp-setup_drivenumbers_exp
		.byte SKIP2
tpcl		ldx #setup_pc_exp-setup_drivenumbers_exp
		lda setup_drivenumbers_exp,x
dlv		jsr drv
		cmp #0
                beq vs
		cmp setup_floppy8_exp
		beq dlv
		cmp setup_floppy9_exp
		beq dlv
		cmp setup_floppy10_exp
		beq dlv
		cmp setup_floppy11_exp
		beq dlv
		cmp setup_hdd0_exp
		beq dlv
		cmp setup_hdd1_exp
		beq dlv
		cmp setup_pc_exp
		beq dlv
vs		sta setup_drivenumbers_exp,x
		rts
;```````````````````````````````````````
thr		#ldatax hour_exp
		jsr incbcd
		bcs *+4
		ldx #$23
		cpx #$24
		lda #$84		;writehour
		gne updatecx
;```````````````````````````````````````
tmn		#ldatax min_exp
		jsr incbcd
		lda #$82		;writemin
tvsz		bcs *+4
		ldx #$59
		cpx #$60
updatecx	#jmps updatec
;```````````````````````````````````````
tsec1		#ldatax sec_exp
		jsr incbcd
		lda #$80		;writesec
		bne tvsz
;```````````````````````````````````````
tyr		#ldatax year_exp
		jsr incbcd
		bcs *+4
		ldx #$99
		cpx #$a0
		lda #$8c		;writeyear
		jsr updatec
		#sty_l_a year_exp
dfix2		lda date_exp
		#jmps dfix
;```````````````````````````````````````
tdt		#ldatax date_exp
		jsr incbcd
		txa
dfix		bne *+5
		jsr monthmax
		sta date_exp
		jsr monthmax
		#ldatax date_exp
		bcs *+4
		ldx #1
		lda #$86		;writedate
		gne updatec2

monthmax
		#ldatax month_exp
		cmp #$02
		bne kqe
		lda year_exp
		jsr bcd2bin
		ldx #2
		and #3
		bne kqe
		ldx #10
kqe		lda monl-1,x
		cmp date_exp
		rts
;```````````````````````````````````````
tmh		#ldatax month_exp
		jsr incbcd
		cpx #1
		bcs *+4
		ldx #$12
		cpx #$13
		bcc *+4
		ldx #1
		lda #$88		;writemonth
		jsr updatec2
		#sty_l_a month_exp
		#jmps dfix2
;```````````````````````````````````````
updatec		bcc updatec2
		ldx #$00
updatec2	php
                pha
		#phx_a
                clc
                sei
		jsr cmos_writeprotect
		#ply_a
                pla
		jsr cmos_start
		tya
		jsr cmos_send_byte
		sta kill_port
                sec
		jsr cmos_writeprotect
                plp
;fall through
;```````````````````````````````````````
incbcd		and #15
		cpy #"-"
		beq decbcd
                #adc1c
		cmp #10
		bcc gr
		txa
		adc #5
		tax
gr		inx
		sec
		rts
;```````````````````````````````````````
decbcd		sbc #1
		bcs gr2
		txa
		sbc #5
		tax
gr2		dex
		rts
;```````````````````````````````````````
backlight	lda #7
		.byte SKIP2
highlight	lda #1
		pha
		ldx hol
		lda mpont,x
		asl a
		asl a
		asl a
		adc #24
		sta $d000
		#lda0
                bcc *+4
                lda #7
		sta $d010
		lda mpont+1,x
		asl a
		sta tmp
		asl a
		asl a
		adc #50
		sta $d001
		sta $d003
		sta $d005
		sbc #49
		clc
		adc tmp
		sta tmp
		asl tmp
		lda #$36
		rol a
		asl tmp
		rol a
		sta tmp+1
		lda mpont+2,x
		ldy mpont,x
		tax
		cpx #3
		#lda0
		bcc sw
		lda #%11110000
		cpx #4
		bcc sw
		lda #%11111111
sw		sta $0341
		sta $0344
		sta $0347
		sta $034a
		#lda0
		cpx #7
		bcc sw2
		lda #%11111111
sw2		sta $0342
		sta $0345
		sta $0348
		sta $034b
		lda $d000
		cpx #7
		bcc sw3
                adc #7
		cpx #8
		bcc sw3
		adc #7
		cpx #11
		bcc sw3
		adc #23
sw3		sta $d002
		cpx #14
		bcc sw4
		adc #23
		cpx #16
		bcc sw4
		adc #15
sw4		sta $d004

		pla
fv		sta (tmp),y
		iny
		dex
		bne fv
		rts
;```````````````````````````````````````
printpg		sta tmp
		sty tmp+1

		lda #<$4a1
		sta togg
		lda #>$4a1
		sta togg+1

		ldx #17
ig2		ldy #37
		lda #32
ig		sta (togg),y
		dey
		bpl ig
		lda togg+1
		pha
		eor #$d8^$04
		sta togg+1
		ldy #37
		lda #7
ig3		sta (togg),y
		dey
		bpl ig3
		pla
		sta togg+1
		lda togg
		clc
		adc #40
		sta togg
		bcc *+4
		inc togg+1
		dex
		bne ig2

		#sta_cfg_16

		clc
		ldy #1
		ldx #4
		jsr $fff0
printpgin       ldy #0
ve		lda (tmp),y
		beq thdho
                cmp #12
                bne *+6
                sta $d3
                lda #29
		jsr newchrout_t
                cmp #13
                bne *+4
                inc $d3
		iny
		bne ve
		inc tmp+1
		bne ve
thdho		rts

;--------------------------------------
;Accu
;
accuconst      	.byte %10100000
		.byte %10101011
		.byte %10100111
		.byte %10101010
		.byte %10100110
		.byte %10101001
		.byte %10100101

battlow		.text "B","A"-64,"T"-64,"T"-64,"E"-64,"R"-64,"Y"-64,32
		.text "W"-64,"A"-64,"S"-64,32
                .text "L"-64,"O"-64,"W"-64,",",32
                .text "C"-64,"H"-64,"E"-64,"C"-64,"K"-64,32
                .text "S"-64,"E"-64,"T"-64,"T"-64,"I"-64,"N"-64,"G"-64,"S"-64,"!"

showclock	= $07e8
hol		= $07e9
retry		= $07ea
m648		= $07eb
ism		= $07ec
datepuff	= $07ed
oldday		= $07ee
setup_accu    	= $07ef
setup_accu_old 	= $07f0
		.pend

;---------------------------------------
;Name of days and months
;
dayc1		.proc
		.text "SMTWTFSJFMAMJJASOND"
		.pend

dayc2		.proc
		.byte $15,$0f,$15,$05
		.byte $08,$12,$01
		.byte $01,$05,$01,$10,$01,$15
		.byte $15,$15,$05,$03,$0f,$05
		.pend

dayc3		.proc
		.byte $0e,$0e,$05,$04
		.byte $15,$09,$14
		.byte $0e,$02,$12,$12,$19,$0e
		.byte $0c,$07,$10,$14,$16,$03
		.pend
